/******************************************************************************
 * $Id: source/xprintf.c, v0.01 6:19 02.01.2011 TiN Exp $
 *
 * Copyright (c) 2010, xDevs.com HC1 Microcontroller Software Support
 *
 * Project maintainers:
 *  o Tsemenko Ilya  (ilya@xdevs.com)
 *  o Alex Gurin     (warder@xdevs.com)
 */

#include "lcd.h"

hc1_lcd_cell_value_t ascii_lut[] =
{
/*
  {0x00, 0x00, 0x02, 0x20, 0x00, 0x00}, // 0x00 - ?????? ??????????.
  {0x00, 0x3e, 0x45, 0x51, 0x45, 0x3e}, // 0x01 - ???? ? ???????.
  {0x00, 0x3e, 0x6b, 0x6f, 0x6b, 0x3e}, // 0x02 - ???? ? ??????? ???????????.
  {0x00, 0x1c, 0x3e, 0x7c, 0x3e, 0x1c}, // 0x03 - ????? (??????).
  {0x00, 0x18, 0x3c, 0x7e, 0x3c, 0x18}, // 0x04 - ?????.
  // 0x05 - ??????.
  {0x00, 0x30, 0x36, 0x7f, 0x36, 0x30},
  // 0x06 - ????.
  {0x00, 0x18, 0x5c, 0x7e, 0x5c, 0x18},
  // 0x07 - ??????????? ???? ?? ??????.
  {0x00, 0x00, 0x18, 0x18, 0x00, 0x00},
  // 0x08 - ??????????? ???? ?? ?????? ? ????????.
  {0xff, 0xff, 0xe7, 0xe7, 0xff, 0xff},
  // 0x09 - ????????????? ???? ?? ??????.
  {0x00, 0x3c, 0x24, 0x24, 0x3c, 0x00},
  // 0x0a - ????????????? ???? ?? ?????? ? ???????? (??????).
  {0xff, 0xc3, 0xdb, 0xdb, 0xc3, 0xff},
  // 0x0b - ??????? ?????? (???? ?? ???????? ?????).
  {0x00, 0x30, 0x48, 0x4a, 0x36, 0x0e},
  // 0x0c - ??????? ?????? (???? ? ??????? ?????).
  {0x00, 0x06, 0x29, 0x79, 0x29, 0x06},
  // 0x0d - ???? I.
  {0x00, 0x60, 0x70, 0x3f, 0x02, 0x04},
  // 0x0e - ???? II.
  {0x00, 0x60, 0x7e, 0x0a, 0x35, 0x3f},
  // 0x0f - ?????? (???? ? ????????????? ??????).
  {0x00, 0x2a, 0x1c, 0x36, 0x1c, 0x2a},
  // 0x10 - ??????? ??????? ??????.
  {0x00, 0x00, 0x7f, 0x3e, 0x1c, 0x08},
  // 0x11 - ??????? ??????? ?????.
  {0x00, 0x08, 0x1c, 0x3e, 0x7f, 0x00},
  // 0x12 - ?????? ??????? ?????-????.
  {0x00, 0x14, 0x36, 0x7f, 0x36, 0x14},
  // 0x13 - ??? ??????????????? ?????.
  {0x00, 0x00, 0x5f, 0x00, 0x5f, 0x00},
  // 0x14 - ?????? "??".
  {0x00, 0x06, 0x09, 0x7f, 0x01, 0x7f},
  // 0x15 - ?????? ?????????.
  {0x00, 0x22, 0x4d, 0x55, 0x59, 0x22},
  // 0x16 - ??????? ?????????????.
  {0x00, 0x60, 0x60, 0x60, 0x60, 0x00},
  // 0x17 - ?????? ??????? ?????-???? ? ??????????????.
  {0x00, 0x14, 0xb6, 0xff, 0xb6, 0x14},
  // 0x18 - ?????? ??????? ?????.
  {0x00, 0x04, 0x06, 0x7f, 0x06, 0x04},
  // 0x19 - ?????? ??????? ????.
  {0x00, 0x10, 0x30, 0x7f, 0x30, 0x10},
  // 0x1a - ?????? ??????? ??????.
  {0x00, 0x08, 0x08, 0x3e, 0x1c, 0x08},
  // 0x1b - ?????? ??????? ?????.
  {0x00, 0x08, 0x1c, 0x3e, 0x08, 0x08},
  // 0x1c - ?????? ???????.
  {0x00, 0x78, 0x40, 0x40, 0x40, 0x40},
  // 0x1d - ?????? ??????? ?????-??????.
  {0x00, 0x08, 0x3e, 0x08, 0x3e, 0x08},
  // 0x1e - ??????? ??????? ?????.
  {0x00, 0x30, 0x3c, 0x3f, 0x3c, 0x30},
  // 0x1f - ??????? ??????? ????.
  {0x00, 0x03, 0x0f, 0x3f, 0x0f, 0x03},*/
  // 0x20 - ?????? (?????? ??????????).
  {0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
  // 0x21 - ??????????????? ????.
  {0x00, 0x00, 0x06, 0x5f, 0x06, 0x00},
  // 0x22 - ??????? ???????.
  {0x00, 0x07, 0x03, 0x00, 0x07, 0x03},
  // 0x23 - ???????.
  {0x00, 0x24, 0x7e, 0x24, 0x7e, 0x24},
  // 0x24 - ??????.
  {0x00, 0x24, 0x2b, 0x6a, 0x12, 0x00},
  // 0x25 - ???????.
  {0x00, 0x63, 0x13, 0x08, 0x64, 0x63},
  // 0x26 - ?????????.
  {0x00, 0x36, 0x49, 0x56, 0x20, 0x50},
  // 0x27 - ????????.
  {0x00, 0x00, 0x07, 0x03, 0x00, 0x00},
  // 0x28 - ??????????? ??????.
  {0x00, 0x00, 0x3e, 0x41, 0x00, 0x00},
  // 0x29 - ??????????? ??????.
  {0x00, 0x00, 0x41, 0x3e, 0x00, 0x00},
  // 0x2a - ????????? (?????????).
  {0x00, 0x08, 0x3e, 0x1c, 0x3e, 0x08},
  // 0x2b - ????.
  {0x00, 0x08, 0x08, 0x3e, 0x08, 0x08},
  // 0x2c - ???????.
  {0x00, 0x00, 0xe0, 0x60, 0x00, 0x00},
  // 0x2d - ????.
  {0x00, 0x08, 0x08, 0x08, 0x08, 0x08},
  // 0x2e - ?????.
  {0x00, 0x00, 0x60, 0x60, 0x00, 0x00},
  // 0x2f - ???? ?????-??????? ('/').
  {0x00, 0x20, 0x10, 0x08, 0x04, 0x02},
  // 0x30 - '0'.
  {0x00, 0x3e, 0x41, 0x41, 0x41, 0x3e},
  // 0x31 - '1'.
  {0x00, 0x00, 0x42, 0x7f, 0x40, 0x00},
  // 0x32 - '2'.
  {0x00, 0x62, 0x51, 0x49, 0x49, 0x46},
  // 0x33 - '3'.
  {0x00, 0x22, 0x49, 0x49, 0x49, 0x36},
  // 0x34 - '4'.
  {0x00, 0x18, 0x14, 0x12, 0x7f, 0x10},
  // 0x35 - '5'.
  {0x00, 0x2f, 0x49, 0x49, 0x49, 0x31},
  // 0x36 - '6'.
  {0x00, 0x3c, 0x4a, 0x49, 0x49, 0x30},
  // 0x37 - '7'.
  {0x00, 0x01, 0x71, 0x09, 0x05, 0x03},
  // 0x38 - '8'.
  {0x00, 0x36, 0x49, 0x49, 0x49, 0x36},
  // 0x39 - '9'.
  {0x00, 0x06, 0x49, 0x49, 0x29, 0x1e},
  // 0x3a - ?????????.
  {0x00, 0x00, 0x6c, 0x6c, 0x00, 0x00},
  // 0x3b - ????? ? ???????.
  {0x00, 0x00, 0xec, 0x6c, 0x00, 0x00},
  // 0x3c - ??????.
  {0x00, 0x08, 0x14, 0x22, 0x41, 0x00},
  // 0x3d - ?????.
  {0x00, 0x24, 0x24, 0x24, 0x24, 0x24},
  // 0x3e - ??????.
  {0x00, 0x00, 0x41, 0x22, 0x14, 0x08},
  // 0x3f - ?????????????? ????.
  {0x00, 0x02, 0x01, 0x59, 0x09, 0x06},
  // 0x40 - "??????" ('@').
  {0x00, 0x3e, 0x41, 0x5d, 0x55, 0x1e},
  // 0x41 - 'A'.
  {0x00, 0x7e, 0x11, 0x11, 0x11, 0x7e},
  // 0x42 - 'B'.
  {0x00, 0x7f, 0x49, 0x49, 0x49, 0x36},
  // 0x43 - 'C'.
  {0x00, 0x3e, 0x41, 0x41, 0x41, 0x22},
  // 0x44 - 'D'.
  {0x00, 0x7f, 0x41, 0x41, 0x41, 0x3e},
  // 0x45 - 'E'.
  {0x00, 0x7f, 0x49, 0x49, 0x49, 0x41},
  // 0x46 - 'F'.
  {0x00, 0x7f, 0x09, 0x09, 0x09, 0x01},
  // 0x47 - 'G'.
  {0x00, 0x3e, 0x41, 0x49, 0x49, 0x7a},
  // 0x48 - 'H'.
  {0x00, 0x7f, 0x08, 0x08, 0x08, 0x7f},
  // 0x49 - 'I'.
  {0x00, 0x00, 0x41, 0x7f, 0x41, 0x00},
  // 0x4a - 'J'.
  {0x00, 0x30, 0x40, 0x40, 0x40, 0x3f},
  // 0x4b - 'K'.
  {0x00, 0x7f, 0x08, 0x14, 0x22, 0x41},
  // 0x4c - 'L'.
  {0x00, 0x7f, 0x40, 0x40, 0x40, 0x40},
  // 0x4d - 'M'.
  {0x00, 0x7f, 0x02, 0x04, 0x02, 0x7f},
  // 0x4e - 'N'.
  {0x00, 0x7f, 0x02, 0x04, 0x08, 0x7f},
  // 0x4f - 'O'.
  {0x00, 0x3e, 0x41, 0x41, 0x41, 0x3e},
  // 0x50 - 'P'.
  {0x00, 0x7f, 0x09, 0x09, 0x09, 0x06},
  // 0x51 - 'Q'.
  {0x00, 0x3e, 0x41, 0x51, 0x21, 0x5e},
  // 0x52 - 'R'.
  {0x00, 0x7f, 0x09, 0x09, 0x19, 0x66},
  // 0x53 - 'S'.
  {0x00, 0x26, 0x49, 0x49, 0x49, 0x32},
  // 0x54 - 'T'.
  {0x00, 0x01, 0x01, 0x7f, 0x01, 0x01},
  // 0x55 - 'U'.
  {0x00, 0x3f, 0x40, 0x40, 0x40, 0x3f},
  // 0x56 - 'V'.
  {0x00, 0x1f, 0x20, 0x40, 0x20, 0x1f},
  // 0x57 - 'W'.
  {0x00, 0x3f, 0x40, 0x3c, 0x40, 0x3f},
  // 0x58 - 'X'.
  {0x00, 0x63, 0x14, 0x08, 0x14, 0x63},
  // 0x59 - 'Y'.
  {0x00, 0x07, 0x08, 0x70, 0x08, 0x07},
  // 0x5a - 'Z'.
  {0x00, 0x71, 0x49, 0x45, 0x43, 0x00},
  // 0x5b - '['.
  {0x00, 0x00, 0x7f, 0x41, 0x41, 0x00},
  // 0x5c - '\'.
  {0x00, 0x02, 0x04, 0x08, 0x10, 0x20},
  // 0x5d - ']'.
  {0x00, 0x00, 0x41, 0x41, 0x7f, 0x00},
  // 0x5e - '^'.
  {0x00, 0x04, 0x02, 0x01, 0x02, 0x04},
  // 0x5f - '_'.
  {0x80, 0x80, 0x80, 0x80, 0x80, 0x80},
  // 0x60 - ???????? ????????.
  {0x00, 0x00, 0x03, 0x07, 0x00, 0x00},
  // 0x61 - 'a'.
  {0x00, 0x20, 0x54, 0x54, 0x54, 0x78},
  // 0x62 - 'b'.
  {0x00, 0x7f, 0x44, 0x44, 0x44, 0x38},
  // 0x63 - 'c'.
  {0x00, 0x38, 0x44, 0x44, 0x44, 0x28},
  // 0x64 - 'd'.
  {0x00, 0x38, 0x44, 0x44, 0x44, 0x7f},
  // 0x65 - 'e'.
  {0x00, 0x38, 0x54, 0x54, 0x54, 0x08},
  // 0x66 - 'f'.
  {0x00, 0x08, 0x7e, 0x09, 0x09, 0x00},
  // 0x67 - 'g'.
  {0x00, 0x18, 0xa4, 0xa4, 0xa4, 0x7c},
  // 0x68 - 'h'.
  {0x00, 0x7f, 0x04, 0x04, 0x78, 0x00},
  // 0x69 - 'i'.
  {0x00, 0x00, 0x00, 0x7d, 0x40, 0x00},
  // 0x6a - 'j'.
  {0x00, 0x40, 0x80, 0x84, 0x7d, 0x00},
  // 0x6b - 'k'.
  {0x00, 0x7f, 0x10, 0x28, 0x44, 0x00},
  // 0x6c - 'l'.
  {0x00, 0x00, 0x00, 0x7f, 0x40, 0x00},
  // 0x6d - 'm'.
  {0x00, 0x7c, 0x04, 0x18, 0x04, 0x78},
  // 0x6e - 'n'.
  {0x00, 0x7c, 0x04, 0x04, 0x78, 0x00},
  // 0x6f - 'o'.
  {0x00, 0x38, 0x44, 0x44, 0x44, 0x38},
  // 0x70 - 'p'.
  {0x00, 0xfc, 0x44, 0x44, 0x44, 0x38},
  // 0x71 - 'q'.
  {0x00, 0x38, 0x44, 0x44, 0x44, 0xfc},
  // 0x72 - 'r'.
  {0x00, 0x44, 0x78, 0x44, 0x04, 0x08},
  // 0x73 - 's'.
  {0x00, 0x08, 0x54, 0x54, 0x54, 0x20},
  // 0x74 - 't'.
  {0x00, 0x04, 0x3e, 0x44, 0x24, 0x00},
  // 0x75 - 'u'.
  {0x00, 0x3c, 0x40, 0x20, 0x7c, 0x00},
  // 0x76 - 'v'.
  {0x00, 0x1c, 0x20, 0x40, 0x20, 0x1c},
  // 0x77 - 'w'.
  {0x00, 0x3c, 0x60, 0x30, 0x60, 0x3c},
  // 0x78 - 'x'.
  {0x00, 0x6c, 0x10, 0x10, 0x6c, 0x00},
  // 0x79 - 'y'.
  {0x00, 0x9c, 0xa0, 0x60, 0x3c, 0x00},
  // 0x7a - 'z'.
  {0x00, 0x64, 0x54, 0x54, 0x4c, 0x00},
  // 0x7b - '{'.
  {0x00, 0x08, 0x3e, 0x41, 0x41, 0x00},
  // 0x7c - '|'.
  {0x00, 0x00, 0x00, 0x77, 0x00, 0x00},
  // 0x7d - '},'.
  {0x00, 0x00, 0x41, 0x41, 0x3e, 0x08},
  // 0x7e - '~'.
  {0x00, 0x02, 0x01, 0x02, 0x01, 0x00},
  // 0x7f - "?????".
  {0x00, 0x3c, 0x26, 0x23, 0x26, 0x3c},
  // 0x80 - ????? ?? ????? ???????????.
  {0x44, 0x11, 0x44, 0x11, 0x44, 0x11},
  // 0x81 - ????? ?? ????? ??????.
  {0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55},
  // 0x82 - ????? ?? ????????.
  {0xbb, 0xee, 0xbb, 0xee, 0xbb, 0xee},
  // 0x83 - ??????? ????? ????????????? - ???????????? ?????.
  {0x00, 0x00, 0x00, 0xff, 0x00, 0x00},
  // 0x84 - ????????????? - ???????????? ????? ? ??????? ?? ?????? ?????.
  {0x08, 0x08, 0x08, 0xff, 0x00, 0x00},
  // 0x85 - ????????????? - ???????????? ????? ? ??????? ??????? ?? ?????? ?????.
  {0x0a, 0x0a, 0x0a, 0xff, 0x00, 0x00},
  // 0x86 - ????????????? - ??????? ???????????? ????? ? ??????? ?? ?????? ?????.
  {0x08, 0xff, 0x00, 0xff, 0x00, 0x00},
  // 0x87 - ????????????? - ??????? ?????? ???? ? ??????? ???????????? ??????.
  {0x08, 0xf8, 0x08, 0xf8, 0x00, 0x00},
  // 0x88 - ????????????? - ??????? ?????? ???? ? ??????? ?????????????? ??????.
  {0x0a, 0x0a, 0x0a, 0xfe, 0x00, 0x00},
  // 0x89 - ????????????? - ??????? ???????????? ????? ? ??????? ??????? ?? ?????? ?????.
  {0x0a, 0xfb, 0x00, 0xff, 0x00, 0x00},
  // 0x8a - ????????????? - ??????? ???????????? ?????.
  {0x00, 0xff, 0x00, 0xff, 0x00, 0x00},
  // 0x8b - ????????????? - ??????? ??????? ?????? ????.
  {0x0a, 0xfa, 0x02, 0xfe, 0x00, 0x00},
  // 0x8c - ????????????? - ??????? ?????? ?????? ????.
  {0x0a, 0x0b, 0x08, 0x0f, 0x00, 0x00},
  // 0x8d - ????????????? - ?????? ?????? ???? ? ??????? ???????????? ??????.
  {0x08, 0x0f, 0x08, 0x0f, 0x00, 0x00},
  // 0x8e - ????????????? - ?????? ?????? ???? ? ??????? ?????????????? ??????.
  {0x0a, 0x0a, 0x0a, 0x0f, 0x00, 0x00},
  // 0x8f - ????????????? - ??????? ?????? ????.
  {0x08, 0x08, 0x08, 0xf8, 0x00, 0x00},
  // 0x90 - ????????????? - ?????? ????? ????.
  {0x00, 0x00, 0x00, 0x0f, 0x08, 0x08},
  // 0x91 - ????????????? - ?????????????? ????? ? ??????? ?? ?????? ?????.
  {0x08, 0x08, 0x08, 0x0f, 0x08, 0x08},
  // 0x92 - ????????????? - ?????????????? ????? ? ??????? ?? ?????? ????.
  {0x08, 0x08, 0x08, 0xf8, 0x08, 0x08},
  // 0x93 - ????????????? - ???????????? ????? ? ??????? ?? ?????? ??????.
  {0x00, 0x00, 0x00, 0xff, 0x08, 0x08},
  // 0x94 - ????????????? - ?????????????? ????? ?? ??????.
  {0x08, 0x08, 0x08, 0x08, 0x08, 0x08},
  // 0x95 - ????????????? - ???????????.
  {0x08, 0x08, 0x08, 0xff, 0x08, 0x08},
  // 0x96 - ????????????? - ???????????? ????? ? ??????? ??????? ?? ?????? ??????.
  {0x00, 0x00, 0x00, 0xff, 0x0a, 0x0a},
  // 0x97 - ????????????? - ??????? ???????????? ????? ? ??????? ?? ?????? ??????.
  {0x00, 0xff, 0x00, 0xff, 0x08, 0x08},
  // 0x98 - ????????????? - ??????? ?????? ????? ????.
  {0x00, 0x0f, 0x08, 0x0b, 0x0a, 0x0a},
  // 0x99 - ????????????? - ??????? ??????? ????? ????.
  {0x00, 0xfe, 0x02, 0xfa, 0x0a, 0x0a},
  // 0x9a - ????????????? - ??????? ?????????????? ????? ? ??????? ??????? ?? ?????? ?????.
  {0x0a, 0x0b, 0x08, 0x0b, 0x0a, 0x0a},
  // 0x9b - ????????????? - ??????? ?????????????? ????? ? ??????? ??????? ?? ?????? ????.
  {0x0a, 0xfa, 0x02, 0xfa, 0x0a, 0x0a},
  // 0x9c - ????????????? - ??????? ???????????? ????? ? ??????? ??????? ?? ?????? ??????.
  {0x00, 0xff, 0x00, 0xfb, 0x0a, 0x0a},
  // 0x9d - ????????????? - ??????? ?????????????? ????? ?? ??????.
  {0x0a, 0x0a, 0x0a, 0x0a, 0x0a, 0x0a},
  // 0x9e - ????????????? - ??????? ???????????.
  {0x0a, 0xfb, 0x00, 0xfb, 0x0a, 0x0a},
  // 0x9f - ????????????? - ??????? ?????????????? ????? ? ??????? ?? ?????? ?????.
  {0x0a, 0x0a, 0x0a, 0x0b, 0x0a, 0x0a},
  // 0xa0 - ????????????? - ?????????????? ????? ? ??????? ??????? ?? ?????? ?????.
  {0x08, 0x0f, 0x08, 0x0f, 0x08, 0x08},
  // 0xa1 - ????????????? - ??????? ?????????????? ????? ? ??????? ?? ?????? ????.
  {0x0a, 0x0a, 0x0a, 0xfa, 0x0a, 0x0a},
  // 0xa2 - ????????????? - ?????????????? ????? ? ??????? ??????? ?? ?????? ????.
  {0x08, 0xf8, 0x08, 0xf8, 0x08, 0x08},
  // 0xa3 - ????????????? - ?????? ????? ????, ??????? ???????????? ?????.
  {0x00, 0x0f, 0x08, 0x0f, 0x08, 0x08},
  // 0xa4 - ????????????? - ?????? ????? ????, ??????? ?????????????? ?????.
  {0x00, 0x00, 0x00, 0x0f, 0x0a, 0x0a},
  // 0xa5 - ????????????? - ??????? ????? ????, ??????? ?????????????? ?????.
  {0x00, 0x00, 0x00, 0xfe, 0x0a, 0x0a},
  // 0xa6 - ????????????? - ??????? ????? ????, ??????? ???????????? ?????.
  {0x00, 0xf8, 0x08, 0xf8, 0x08, 0x08},
  // 0xa7 - ????????????? - ??????? ???????????? ????? ?? ?????? ? ???????? ?????? ? ?????.
  {0x08, 0xff, 0x08, 0xff, 0x08, 0x08},
  // 0xa8 - '?'.
  {0x00, 0x7e, 0x4b, 0x4a, 0x4b, 0x42},
  // 0xa9 - ????????????? - ??????? ?????????????? ????? ?? ?????? ? ???????? ????? ? ????.
  {0x0a, 0x0a, 0x0a, 0xff, 0x0a, 0x0a},
  // 0xaa - ????????????? - ?????? ?????? ????.
  {0x08, 0x08, 0x08, 0x0f, 0x00, 0x00},
  // 0xab - ????????????? - ??????? ????? ????.
  {0x00, 0x00, 0x00, 0xf8, 0x08, 0x08},
  // 0xac - ????????????? - ??????????? ??????????.
  {0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
  // 0xad - ????????????? - ??????????? ?????? ???????? ??????????.
  {0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0},
  // 0xae - ????????????? - ??????????? ????? ???????? ??????????.
  {0xff, 0xff, 0xff, 0x00, 0x00, 0x00},
  // 0xaf - ????????????? - ??????????? ?????? ???????? ??????????.
  {0x00, 0x00, 0x00, 0xff, 0xff, 0xff},
  // 0xb0 - ????????????? - ??????????? ??????? ???????? ??????????.
  {0x00, 0x00, 0x06, 0x09, 0x09, 0x06},
  // 0xb1 - ?????????? '?'.
  {0x00, 0x3e, 0x49, 0x49, 0x41, 0x22},
  // 0xb2 - ?????????? '?'.
  {0x00, 0x38, 0x54, 0x54, 0x44, 0x28},
  // 0xb3 - 'I' ? ????? ??????? ??????.
  {0x00, 0x01, 0x40, 0x7e, 0x40, 0x01},
  // 0xb4 - 'i' ? ????? ??????? ??????.
  {0x00, 0x00, 0x01, 0x7c, 0x41, 0x00},
  // 0xb5 - 'Y' ? ??????? ?????? ('~').
  {0x00, 0x27, 0x48, 0x4b, 0x48, 0x3f},
  // 0xb6 - 'y' ? ??????? ?????? ('~').
  {0x00, 0x9d, 0xa2, 0x62, 0x3d, 0x00},
  // 0xb7 - ????????? ?????? ??????.
  {0x00, 0x06, 0x09, 0x09, 0x06, 0x00},
  // 0xb8 - '?'.
  {0x00, 0x38, 0x55, 0x54, 0x55, 0x08},
  // 0xb9 - ??????? ??????????? ???? ?? ??????.
  {0x00, 0x00, 0x18, 0x18, 0x00, 0x00},
  // 0xba - ????????? ??????????? ???? ?? ??????.
  {0x00, 0x00, 0x08, 0x00, 0x00, 0x00},
  // 0xbb - ?????? ????? ???????????.
  {0x00, 0x30, 0x40, 0x3e, 0x02, 0x02},
  // 0xbc - '?'.
  {0x7f, 0x06, 0x18, 0x7f, 0x13, 0x13},
  // 0xbd - "??????".
  {0x2a, 0x3e, 0x14, 0x14, 0x3e, 0x2a},
  // 0xbe - ??????????? ??????? ?? ??????.
  {0x00, 0x3c, 0x3c, 0x3c, 0x3c, 0x00},
  // 0xbf - ?????? ??????????.
  {0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
  // 0xc0 - '?'.
  {0x00, 0x7e, 0x11, 0x11, 0x11, 0x7e},
  // 0xc1 - '?'.
  {0x00, 0x7f, 0x49, 0x49, 0x49, 0x31},
  // 0xc2 - '?'.
  {0x00, 0x7f, 0x49, 0x49, 0x49, 0x36},
  // 0xc3 - '?'.
  {0x00, 0x7f, 0x01, 0x01, 0x01, 0x01},
  // 0xc4 - '?'.
  {0xc0, 0x7e, 0x41, 0x41, 0x7f, 0xc0},
  // 0xc5 - '?'.
  {0x00, 0x7f, 0x49, 0x49, 0x49, 0x41},
  // 0xc6 - '?'.
  {0x00, 0x77, 0x08, 0x7f, 0x08, 0x77},
  // 0xc7 - '?'.
  {0x22, 0x49, 0x49, 0x49, 0x36, 0x00},
  // 0xc8 - '?'.
  {0x00, 0x7f, 0x20, 0x10, 0x08, 0x7f},
  // 0xc9 - '?'.
  {0x00, 0x7e, 0x21, 0x11, 0x09, 0x7e},
  // 0xca - '?'.
  {0x00, 0x7f, 0x08, 0x14, 0x22, 0x41},
  // 0xcb - '?'.
  {0x00, 0x40, 0x7e, 0x01, 0x01, 0x7f},
  // 0xcc - '?'.
  {0x00, 0x7f, 0x02, 0x04, 0x02, 0x7f},
  // 0xcd - '?'.
  {0x00, 0x7f, 0x08, 0x08, 0x08, 0x7f},
  // 0xce - '?'.
  {0x00, 0x3e, 0x41, 0x41, 0x41, 0x3e},
  // 0xcf - '?'.
  {0x00, 0x7f, 0x01, 0x01, 0x01, 0x7f},
  // 0xd0 - '?'.
  {0x00, 0x7f, 0x09, 0x09, 0x09, 0x06},
  // 0xd1 - '?'.
  {0x00, 0x3e, 0x41, 0x41, 0x41, 0x22},
  // 0xd2 - '?'.
  {0x00, 0x01, 0x01, 0x7f, 0x01, 0x01},
  // 0xd3 - '?'.
  {0x00, 0x27, 0x48, 0x48, 0x48, 0x3f},
  // 0xd4 - '?'.
  {0x00, 0x0e, 0x11, 0x7f, 0x11, 0x0e},
  // 0xd5 - '?'.
  {0x00, 0x63, 0x14, 0x08, 0x14, 0x63},
  // 0xd6 - '?'.
  {0x00, 0x7f, 0x40, 0x40, 0x7f, 0xc0},
  // 0xd7 - '?'.
  {0x00, 0x07, 0x08, 0x08, 0x08, 0x7f},
  // 0xd8 - '?'.
  {0x00, 0x7f, 0x40, 0x7f, 0x40, 0x7f},
  // 0xd9 - '?'.
  {0x00, 0x7f, 0x40, 0x7f, 0x40, 0xff},
  // 0xda - '?'.
  {0x03, 0x01, 0x7f, 0x48, 0x48, 0x30},
  // 0xdb - '?'.
  {0x00, 0x7f, 0x48, 0x48, 0x30, 0x7f},
  // 0xdc - '?'.
  {0x00, 0x7f, 0x48, 0x48, 0x48, 0x30},
  // 0xdd - '?'.
  {0x00, 0x22, 0x41, 0x49, 0x49, 0x3e},
  // 0xde - '?'.
  {0x00, 0x7f, 0x08, 0x3e, 0x41, 0x3e},
  // 0xdf - '?'.
  {0x00, 0x66, 0x19, 0x09, 0x09, 0x7f},
  // 0xe0 - '?'.
  {0x00, 0x20, 0x54, 0x54, 0x54, 0x78},
  // 0xe1 - '?'.
  {0x00, 0x3c, 0x4a, 0x4a, 0x4a, 0x31},
  // 0xe2 - '?'.
  {0x00, 0x7c, 0x54, 0x54, 0x54, 0x28},
  // 0xe3 - '?'.
  {0x00, 0x7c, 0x04, 0x04, 0x0c, 0x00},
  // 0xe4 - '?'.
  {0xc0, 0x78, 0x44, 0x44, 0x7c, 0xc0},
  // 0xe5 - '?'.
  {0x00, 0x38, 0x54, 0x54, 0x54, 0x08},
  // 0xe6 - '?'.
  {0x00, 0x6c, 0x10, 0x7c, 0x10, 0x6c},
  // 0xe7 - '?'.
  {0x00, 0x28, 0x44, 0x54, 0x54, 0x28},
  // 0xe8 - '?'.
  {0x00, 0x7c, 0x20, 0x10, 0x08, 0x7c},
  // 0xe9 - '?'.
  {0x00, 0x7c, 0x20, 0x12, 0x0a, 0x7c},
  // 0xea - '?'.
  {0x00, 0x7c, 0x10, 0x28, 0x44, 0x00},
  // 0xeb - '?'.
  {0x40, 0x38, 0x04, 0x04, 0x7c, 0x00},
  // 0xec - '?'.
  {0x00, 0x7c, 0x08, 0x10, 0x08, 0x7c},
  // 0xed - '?'.
  {0x00, 0x7c, 0x10, 0x10, 0x10, 0x7c},
  // 0xee - '?'.
  {0x00, 0x38, 0x44, 0x44, 0x44, 0x38},
  // 0xef - '?'.
  {0x00, 0x7c, 0x04, 0x04, 0x04, 0x7c},
  // 0xf0 - '?'.
  {0x00, 0xfc, 0x44, 0x44, 0x44, 0x38},
  // 0xf1 - '?'.
  {0x00, 0x38, 0x44, 0x44, 0x44, 0x28},
  // 0xf2 - '?'.
  {0x00, 0x04, 0x04, 0x7c, 0x04, 0x04},
  // 0xf3 - '?'.
  {0x00, 0x9c, 0xa0, 0x60, 0x3c, 0x00},
  // 0xf4 - '?'.
  {0x00, 0x18, 0x24, 0x7c, 0x24, 0x18},
  // 0xf5 - '?'.
  {0x00, 0x6c, 0x10, 0x10, 0x6c, 0x00},
  // 0xf6 - '?'.
  {0x00, 0x7c, 0x40, 0x40, 0x7c, 0xc0},
  // 0xf7 - '?'.
  {0x00, 0x0c, 0x10, 0x10, 0x10, 0x7c},
  // 0xf8 - '?'.
  {0x00, 0x7c, 0x40, 0x7c, 0x40, 0x7c},
  // 0xf9 - '?'.
  {0x00, 0x7c, 0x40, 0x7c, 0x40, 0xfc},
  // 0xfa - '?'.
  {0x0c, 0x04, 0x7c, 0x50, 0x50, 0x20},
  // 0xfb - '?'.
  {0x00, 0x7c, 0x50, 0x50, 0x20, 0x7c},
  // 0xfc - '?'.
  {0x00, 0x7c, 0x50, 0x50, 0x50, 0x20},
  // 0xfd - '?'.
  {0x00, 0x28, 0x44, 0x54, 0x54, 0x38},
  // 0xfe - '?'.
  {0x00, 0x7c, 0x10, 0x38, 0x44, 0x38},
  // 0xff - '?'.
  {0x00, 0x48, 0x34, 0x14, 0x14, 0x7c},
  
  /*Temp rise*/
  {0x00, 0xEB, 0xE9, 0x08, 0xE9, 0xEB},
  /*Temp down*/
  {0x00, 0xEE, 0xEC, 0x08, 0xEC, 0xEE},
  /*Moisture detected*/
  {0x00, 0x94, 0xAA, 0xB6, 0xAA, 0x94},
  /*Moisture clean*/
  {0x00, 0x9C, 0xBE, 0xBE, 0xBE, 0x9C},
  /*Moisture detected var2*/
  {0x00, 0x80, 0xBE, 0xAA, 0xBE, 0x80},
  /*Moisture clean var2*/
  {0x00, 0x80, 0xBE, 0xBE, 0xBE, 0x80},
  /*Temp set var2*/
  {0x00, 0xFE, 0xFE, 0x00, 0xFE, 0xFE},
  /*Temp set*/
  {0x00, 0xFF, 0xFD, 0x80, 0xBD, 0xFF}
};

unsigned char data[544] = {
    0x7F, 0xFC, 0xCF, 0xE6, 0x87, 0xC2, 0x83, 0x82, 0xC1, 0x06, 0xE0, 0x0E, 0xF0, 0x1E, 0xF8, 0x3E,
    0xF0, 0x1E, 0xE0, 0x0E, 0xC1, 0x06, 0x83, 0x82, 0x87, 0xC2, 0xCF, 0xE6, 0x7F, 0xFC,
    //1 : symbol YES
    0x7F, 0xFC, 0xFD, 0xFE, 0xF8, 0xFE, 0xF1, 0xFE, 0xE3, 0xFE, 0xC7, 0xFE, 0xE3, 0xFE, 0xF1, 0xFE,
    0xF8, 0xFE, 0xFC, 0x7E, 0xFE, 0x3E, 0xFF, 0x1E, 0xFF, 0x8E, 0xFF, 0xDE, 0x7F, 0xFC,
    //2 : settings
    0x7F, 0xFC, 0xFF, 0xFE, 0xC0, 0x06, 0xDF, 0xF6, 0xD0, 0x16, 0xDF, 0xF6, 0xD0, 0x96, 0xDF, 0xF6,
    0xD4, 0x16, 0xDF, 0xF6, 0xD0, 0x16, 0xDF, 0xF6, 0xC0, 0x06, 0xFF, 0xFE, 0x7F, 0xFC,
    //3 : clock
    0x7F, 0xFC, 0xF8, 0x3E, 0xE5, 0x4E, 0xD7, 0xD6, 0xDF, 0xF6, 0x9B, 0xEA, 0xBD, 0xFA, 0x9E, 0x02,
    0xBD, 0xFA, 0xBB, 0xEA, 0xD7, 0xF6, 0xCF, 0xD6, 0xE5, 0x4E, 0xF8, 0x3E, 0x7F, 0xFC,
    //4 : stop, hand
    0x7F, 0xFC, 0xFF, 0xFE, 0xC2, 0x0E, 0x82, 0x06, 0x83, 0xFE, 0x81, 0x02, 0x81, 0x02, 0x81, 0xFE,
    0x81, 0x02, 0x81, 0x06, 0x83, 0xFE, 0xC0, 0x0E, 0xE0, 0x1E, 0xFF, 0xFE, 0x7F, 0xFC,
    //5 : skull solid
    0x7F, 0xFC, 0xFE, 0x0E, 0xFC, 0x06, 0xC4, 0x66, 0xC4, 0x66, 0xFC, 0x26, 0xC5, 0x06, 0xC4, 0x06,
    0xC5, 0x06, 0xFC, 0x26, 0xC4, 0x66, 0xC4, 0x66, 0xFC, 0x06, 0xFE, 0x0E, 0x7F, 0xFC,
    //6 : save changes
    0x7F, 0xFC, 0xFF, 0xFE, 0xE0, 0x06, 0xDF, 0xF6, 0xDE, 0x06, 0xC2, 0xF6, 0xDA, 0xF6, 0xC2, 0xF6,
    0xC2, 0xF6, 0xC2, 0xF6, 0xDE, 0x06, 0xDF, 0xF6, 0xC0, 0x06, 0xFF, 0xFE, 0x7F, 0xFC,
    //7 : home
    0x7F, 0xFC, 0xFF, 0x7E, 0xFF, 0x3E, 0xC0, 0x1E, 0xC0, 0x0E, 0xDB, 0x06, 0xDB, 0x02, 0xC0, 0x02,
    0xFB, 0x02, 0xFB, 0x06, 0xC0, 0x0E, 0xC0, 0x06, 0xFF, 0x3E, 0xFF, 0x7E, 0x7F, 0xFC,
    //8 : lock
    0x7F, 0xFC, 0xFF, 0xFE, 0xC0, 0xFE, 0xC0, 0x1E, 0xC0, 0x0E, 0xC0, 0xE6, 0xC0, 0xF6, 0xC0, 0xF6,
    0xC0, 0xF6, 0xC0, 0xE6, 0xC0, 0x0E, 0xC0, 0x1E, 0xC0, 0xFE, 0xFF, 0xFE, 0x7F, 0xFC,
    //9 : contrast
    0x7F, 0xFC, 0xFC, 0x7E, 0xF3, 0x9E, 0xEF, 0xEE, 0xDF, 0xF6, 0xDF, 0xF6, 0xBF, 0xFA, 0x80, 0x02,
    0x80, 0x02, 0xC0, 0x06, 0xC0, 0x06, 0xE0, 0x0E, 0xF0, 0x1E, 0xFC, 0x7E, 0x7F, 0xFC,
    //10 : brightness of LCD
    0x7F, 0xFC, 0xF0, 0x1E, 0xF7, 0xDE, 0xB4, 0x5A, 0xD5, 0xD6, 0xF7, 0xDE, 0xF4, 0x5E, 0x95, 0x52,
    0xF7, 0xDE, 0xF4, 0x5E, 0xD5, 0x56, 0xB6, 0xDA, 0xF7, 0xDE, 0xF0, 0x1E, 0x7F, 0xFC,
    //11 : sandbox timer
    0x7F, 0xFC, 0xFF, 0xFE, 0xDF, 0xF6, 0xC7, 0xC6, 0xDB, 0xB6, 0xDD, 0x76, 0xCE, 0x36, 0xCB, 0x16,
    0xCE, 0x36, 0xDD, 0x76, 0xDB, 0xB6, 0xC7, 0xC6, 0xDF, 0xF6, 0xFF, 0xFE, 0x7F, 0xFC,
    //12 : channels
    0x7F, 0xFC, 0xFF, 0xFE, 0xFD, 0xFE, 0xC0, 0x06, 0xFD, 0xFE, 0xFF, 0xFE, 0xFF, 0xDE, 0xC0, 0x06,
    0xFF, 0xDE, 0xFF, 0xFE, 0xEF, 0xFE, 0xC0, 0x06, 0xEF, 0xFE, 0xFF, 0xFE, 0x7F, 0xFC,
    //13 : modes
    0x7F, 0xFC, 0xFF, 0xFE, 0xC3, 0x86, 0xC7, 0xC6, 0xC3, 0x86, 0xD1, 0x16, 0xFB, 0xBE, 0xFF, 0xFE,
    0xFB, 0xBE, 0xD1, 0x16, 0xC3, 0x86, 0xC7, 0xC6, 0xC3, 0x86, 0xFF, 0xFE, 0x7F, 0xFC,
    //14 : temp set
    0x7F, 0xFC, 0xFF, 0xFE, 0xFF, 0xDE, 0xFF, 0xDE, 0xC0, 0x06, 0xDF, 0xDE, 0xDF, 0xDE, 0xFD, 0xFE, 
    0xFD, 0xFE, 0xFD, 0xFE, 0xF0, 0x7E, 0xF8, 0xFE, 0xFD, 0xFE, 0xFF, 0xFE, 0x7F, 0xFC,
    //15 : eventlog
    0x7F, 0xFC, 0xFF, 0xFE, 0xEA, 0xAE, 0xC0, 0x06, 0xDF, 0xF6, 0xD5, 0x56, 0xD5, 0x56, 0xD5, 0x56, 
    0xD5, 0x56, 0xD5, 0x56, 0xD5, 0x56, 0xDF, 0xF6, 0xC0, 0x06, 0xFF, 0xFE, 0x7F, 0xFC
};

/*hc1_lcd_icon_value_t icon_lut[] =
{
    {0xFC, 0x0E, 0x06, 0x66, 0x66, 0x26, 0x06, 0x06, 0x06, 0x26, 0x66, 0x66, 0x06, 0x0E, 0xFC, 
     0x7F, 0xFE, 0xFC, 0xC4, 0xC4, 0xFC, 0xC5, 0xC4, 0xC5, 0xFC, 0xC4, 0xC4, 0xFC, 0xFE, 0x7F}
};*/

//    0x7F, 0xFC, 0xFE, 0x0E, 0xFC, 0x06, 0xC4, 0x66, 0xC4, 0x66, 0xFC, 0x26, 0xC5, 0x06, 0xC4, 
//    0x06, 0xC5, 0x06, 0xFC, 0x26, 0xC4, 0x66, 0xC4, 0x66, 0xFC, 0x06, 0xFE, 0x0E, 0x7F, 0xFC,

